(function () {
    "use strict";

    angular.module('core').controller('clienteVarejoDetailController', controller);
    controller.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'contatoService', 'empresaService', '$alert','lookupService','$q'];

    function controller($scope, $timeout, $state, $stateParams, contatoService, empresaServicem, $alert, lookupService,$q) {
        $scope.initializeLayout('Cliente de Varejo');

        //[Inicializa objetos]
        $scope.state = {
            item: { ID: decodeURIComponent($stateParams.id) },
            carregando: false,
            vazio: false,
        };
        $scope.popups = {
            empresas: { ativo: false }
        };


        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.auxiliar = {
            empresas: { data: [], carregando: false, vazio: true, count: 0, args: { filtro: { ContatoPrincipal: { ID: decodeURIComponent($stateParams.id) } }, skip: 0, take: 999999 } },
            tipocliente: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllTipoCliente({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                },
            },
            empresa: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllEmpresa({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            loja: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllLoja({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            vendedor: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllVendedor({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else {
                                    return response.Data;
                                }

                            })
                    );
                },
            },
            endereco: {
                prepare: function (index) {
                    contatoService
                        .prepareEndereco($scope.state.item.Enderecos[index])
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item.Enderecos[index] = response.Data;
                                $('[ng-model$="item.Linha2"]').focus();
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });
                },
                prepareNew: function () {
                    contatoService
                        .prepareNewEndereco($scope.state.item)
                        .then(
                        function (response) {
                            if (response.Status < 0) {
                                $scope.tools.toastr.error(response.Message, 'Serviço');
                            } else {
                                $scope.state.item = response.Data;
                            }
                        },
                        function (_error) {
                            $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                        });

                },
            },
        };

        $scope.save = function () {
            $scope.state.salvando = true;
            contatoService
                .save($scope.state.item)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.state.salvando = false;
                            $alert({ text: response.Message, title: $scope.Title });
                        } else {
                            $scope.historyBack();
                        }
                    },
                    function (_error) {
                        $scope.state.salvando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    });
        };


        $scope.get = function () {
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contatoService
                .get($scope.state.item)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                        console.error(response.Exception);
                    } else {
                        $scope.state.item = response.Data;
                    }
                    $scope.state.carregando = false;
                    $scope.state.vazio = !$scope.state.item;
                },
                function (_error) {
                    $scope.state.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    console.error(_error);
                }
                );
        };
        $scope.refresh = function () {
            $scope.get();
        };

        $scope.toggleEmpresas = function () {
            $scope.popups.empresas.ativo = !$scope.popups.empresas.ativo;
            if ($scope.popups.empresas.ativo) {
                $scope.getAllEmpresa();
            }
        };

        $scope.getAllEmpresa = function () {
            $scope.auxiliar.empresas.carregando = true;
            $scope.auxiliar.empresas.vazio = false;
            empresaService
                .getAll($scope.auxiliar.empresas.args)
                .then(
                function (response) {
                    if (response.Status < 0) {
                        console.error(response.Exception);
                        $scope.tools.toastr.error(response.Message, 'Serviço');
                    } else {
                        angular.copy(angular.fromJson(response.Data), $scope.auxiliar.empresas.data);
                    }
                    $scope.auxiliar.empresas.carregando = false;
                    $scope.auxiliar.empresas.vazio = !response.Data.length;
                },
                function (_error) {
                    $scope.auxiliar.empresas.carregando = false;
                    $scope.tools.toastr.error('Não foi possível acessar o(s) servidor(es)');
                    console.error(_error);
                });
        }

        /*Inicializa funções*/
        $scope.initialize();

    }

})();